<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
  <title> pcb-rnd rosetta drill list exporter </title>
  <meta http-equiv="Content-Type" content="text/html;charset=us-ascii">
</head>
<body>
<!-- ******* DO NOT EDIT THIS FILE, it is generated by rosetta_genpages.sh ******* -->
&lt;-- back to the <a href="../index.html">index of Rosetta examples</a>
<h1>drill list exporter</h1>
Create a new exporter that prints a list of drills in x,y,dia table in CSV, TSV or text format
<H2> Example implementations </H2>
<a href="ex.awk">awk</a>
 | 
<a href="ex.lua">lua</a>
 | 
<a href="ex.tcl">tcl</a>
<h2> Explanation, step by step </h2>

<!-- TODO: move this to the high level doc --> An exporter is a hid registered. During the export process, pcb-rnd calls the exporter to draw objects on layers. The GPMI layer converts these calls to bindable events. An exporter script catches the drawing events relevant to the output format and draws everything from event handlers.  
<p> An exporter is sort of a drawing backend: pcb-rnd sets up graphic contexts (gc for short) and draws on them. The first gc set up should open the output file, the last gc closed should flush/close the file. 
<p> 
<hr>  
<h3>Theory of operation</h3>
 Assume only 
<b>filled circles</b>
 on the  
<b>top assembly layer</b>
 are holes. Emit a line for each of these and ignore everything else.  
<h3> Implementation </h3>
 Load packages the script depends on: 
<ul> 	
<li> 
<i>hid</i>
 for registering the new exporter; 	
<li> 
<i>layout</i>
 for unit conversion; 	
<li> 
<i>dialogs</i>
 for error reporting. </ul>
 
<p> Set up an exporter hid, storing the handle of each object created in a global variable: 
<ul> 	
<li> create a hid using 
<i><a href="../../packages/hid_ref.html#hid_create">hid_create</a></i>
 	
<li> add two attributes (fields) to the dialog using 
<i><a href="../../packages/hid_ref.html#hid_add_attribute">hid_add_attribute</a></i>
 	
<li> register the new hid using 
<i><a href="../../packages/hid_ref.html#hid_register">hid_register</a></i>
 - this makes it an exporter </ul>
 
<p> Set up global state variables: 
<ul> 	
<li> fmt will be a cache for the format selected by the user 	
<li> conv is the conversion scale between mm and PCB internal coordinate unit 	
<li> channel specifies a file handle or indicates that the output file is open 	
<li> green_light indicates that the exporter is drawing the relevant layer </ul>
 
<p> Define a 
<i>make_gc</i>
 callback. It is called when a new graphic context is created (e.g. for layers).  An exporter is sort of a drawing backend: pcb-rnd sets up gc's and draws on them. The first gc set up should open the output file, the last gc closed should flush/close the file. Define a 
<i>destroy_gc</i>
 callback for the latter. GCs are destroyed at the end of the export process. Use global variable 
<i>channel</i>
 to make sure the file is open/close only once (see TODO 
<i>script context</i>
). 
<p> Define a 
<i>set_layer</i>
 callback that sets green_light to true if layer name is "topasssembly", false otherwise. 
<p> Callback 
<i>fill_circle</i>
 is the workhorse: check if we have the green light to emit lines, then convert coordinates and diameter to mm and decide what format to use for printing a line for each filled circle. 
<p> Finally, bind all four callbacks to exporter events.   
</body>
</html>
